Bug 832635 - Review Request: pencil - A sketching and GUI prototyping tool
Review Request: pencil - A sketching and GUI prototyping tool
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Matthias Runge
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-06-16 02:21 EDT by Truong Anh Tuan
Modified: 2012-10-13 23:22 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-10-01 13:25:05 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mrunge: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Truong Anh Tuan 2012-06-16 02:21:07 EDT
Spec URL: http://tuanta.fedorapeople.org/pencil/pencil.spec
SRPM URL: http://tuanta.fedorapeople.org/pencil/pencil-2.0-1.fc17.src.rpm
Description: Pencil is an open source GUI prototyping and sketching tools released under GPL.
Fedora Account System Username: tuanta
Comment 1 Fabian Affolter 2012-06-19 10:35:06 EDT
just some quick comments:

- %defattr is no longer needed, it's the default
- 'BuildRoot' is obsolete for recent Fedora versions.
- The .desktop file is not handled correct, https://fedoraproject.org/wiki/Packaging:Guidelines#Desktop_files
- http://evoluspencil.googlecode.com/files/pencil-2.0.tar.gz gives an 404 error
Comment 2 Truong Anh Tuan 2012-06-20 00:33:08 EDT
(In reply to comment #1)
> just some quick comments:
> 
> - %defattr is no longer needed, it's the default
> - 'BuildRoot' is obsolete for recent Fedora versions.

Thanks. They would be removed.

> - The .desktop file is not handled correct,
> https://fedoraproject.org/wiki/Packaging:Guidelines#Desktop_files

I have read these instructions more. Could you tell me more detailed what's wrong with it?

> - http://evoluspencil.googlecode.com/files/pencil-2.0.tar.gz gives an 404
> error

Actually, the upstream developer did not release the whole software source as a tar file like this. He sent me this SVN link: http://evoluspencil.googlecode.com/svn/branches/pencil-2.0
I got sources, change some file/folder locations then build myself (of course, I notified my changes to him)
Comment 3 Fabian Affolter 2012-06-20 18:00:55 EDT
(In reply to comment #2)
> (In reply to comment #1)
> > - The .desktop file is not handled correct,
> > https://fedoraproject.org/wiki/Packaging:Guidelines#Desktop_files
> 
> I have read these instructions more. Could you tell me more detailed what's
> wrong with it?

The .desktop file is not installed.

> > - http://evoluspencil.googlecode.com/files/pencil-2.0.tar.gz gives an 404
> > error
> 
> Actually, the upstream developer did not release the whole software source
> as a tar file like this. He sent me this SVN link:
> http://evoluspencil.googlecode.com/svn/branches/pencil-2.0
> I got sources, change some file/folder locations then build myself (of
> course, I notified my changes to him)

It's not going to fly...downloading source code, modify it locally, and then use that code is not the way it works. When you are using a scm checkout/snapshot, notes about the details should be mentioned in the spec file and the numbering should reflect it too. I suggest that you try to convince upstream to make a proper release.

btw, rpmlint says:
[fab@laptop11 noarch]$ rpmlint pencil-2.0-1.fc17.noarch.rpm 
pencil.noarch: E: zero-length /usr/share/pencil/content/pencil/templates/ODT/default.ODT/Configurations2/accelerator/current.xml
pencil.noarch: E: zero-length /usr/share/pencil/skin/classic/pencil.css
pencil.noarch: E: zero-length /usr/share/pencil/content/pencil/templates/HTML/default.HTML/Resources/SampleStyle.css
pencil.noarch: W: no-manual-page-for-binary pencil
1 packages and 0 specfiles checked; 3 errors, 1 warnings.
Comment 4 Volker Fröhlich 2012-08-05 03:35:59 EDT
Truong, did you find the time to correct these issues?
Comment 5 Truong Anh Tuan 2012-08-05 21:59:07 EDT
(In reply to comment #4)
> Truong, did you find the time to correct these issues?

I am waiting for upstream developer to correct all (I did some and sent him my patches).
Good news: I will have a meeting with him this Saturday morning.
Comment 6 Truong Anh Tuan 2012-09-26 10:53:16 EDT
All necessary changes have been made.

Updated .spec file: http://tuanta.fedorapeople.org/pencil/pencil.spec
And new .src file: http://tuanta.fedorapeople.org/pencil/pencil-2.0-2.fc17.src.rpm

Please help me to review the package.

Rgds,
Tuan
Comment 7 Volker Fröhlich 2012-09-26 11:02:50 EDT
No prebuilt binaries!
Comment 8 Truong Anh Tuan 2012-09-26 11:10:05 EDT
You meant the file /usr/bin/pencil, right?
It's just a shell script file, not a binary.
Comment 9 Volker Fröhlich 2012-09-26 11:12:31 EDT
I'm sorry!
Comment 10 Truong Anh Tuan 2012-09-27 02:48:10 EDT
(In reply to comment #9)
> I'm sorry!

No problem! :)

Also, could you please help me to review this package, or I need to wait for another one?
Comment 11 Matthias Runge 2012-09-27 03:00:56 EDT
- no %clean section required anymore
- there are two license files

I'll do a full review today.
Comment 12 Truong Anh Tuan 2012-09-27 03:12:32 EDT
(In reply to comment #11)
> - no %clean section required anymore

Thanks, I will be removed.

> - there are two license files

I see one is out of usr/ folder, but where is the other?

> I'll do a full review today.

Thanks. Hope this useful tool will be available in Fedora repo soon.
Comment 13 Matthias Runge 2012-09-27 03:55:36 EDT
(In reply to comment #12)
> (In reply to comment #11)
> > - no %clean section required anymore
> 
> Thanks, I will be removed.
> 
> > - there are two license files
> 
> I see one is out of usr/ folder, but where is the other?
COPYING and
usr/share/pencil/license.txt

both files are identical.

which one goes to %doc? what happens to the other?

Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== Generic ====
[x]: EXTRA Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: EXTRA Spec file according to URL is the same as in SRPM.
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[-]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[x]: MUST Package contains desktop file if it is a GUI application.
[x]: MUST Package installs a %{name}.desktop using desktop-file-install if
     there is such a file.
[-]: MUST Development files must be in a -devel package
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Package complies to the Packaging Guidelines
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf would be needed if support for EPEL5 is required
[-]: MUST Large documentation files are in a -doc subpackage, if required.
[!]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[!]: MUST License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.
[x]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: MUST Package is named using only allowed ascii characters.
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[-]: MUST If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Package is not relocatable.
[x]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains systemd file(s) if in need.
[x]: MUST File names are valid UTF-8.
[x]: SHOULD Reviewer should test that the package builds in mock.
[x]: SHOULD Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[!]: SHOULD Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean is needed only if supporting EPEL5
[x]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: SHOULD Package functions as described.
[x]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD SourceX tarball generation or download is documented.
[x]: SHOULD SourceX / PatchY prefixed with %{name}.
[x]: SHOULD SourceX is a working URL.
[x]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[-]: SHOULD %check is present and all tests pass.
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.

Issues:
[!]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
See: http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License_Text


Rpmlint
-------
Checking: pencil-2.0-2.fc19.src.rpm
          pencil-2.0-2.fc19.noarch.rpm
pencil.src: W: invalid-url Source0: http://evoluspencil.googlecode.com/files/pencil-2.0.tar.gz HTTP Error 404: Not Found
pencil.noarch: W: no-manual-page-for-binary pencil
2 packages and 0 specfiles checked; 0 errors, 2 warnings.


Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:
Requires
--------
pencil-2.0-2.fc19.noarch.rpm (rpmlib, GLIBC filtered):
    
    /bin/sh  
    xulrunner >= 1.9.8

Provides
--------
pencil-2.0-2.fc19.noarch.rpm:
    
    mimehandler(application/ep)  
    pencil = 2.0-2.fc19

MD5-sum check
-------------
http://evoluspencil.googlecode.com/files/pencil-2.0.tar.gz :
  CHECKSUM(SHA256) this package     : b3628870d29a4377f63f986b8865c8a20a4b8fe925c2e0ce704cffc17a313fe8
  CHECKSUM(SHA256) upstream package : b3628870d29a4377f63f986b8865c8a20a4b8fe925c2e0ce704cffc17a313fe8


Generated by fedora-review 0.2.2 (9f8c0e5) last change: 2012-08-09
Command line :/usr/bin/fedora-review -b 832635


Issues:

- please clarify with upstream, which license is is the one to use, ask upstream to delete the other
- there are several files from windows included. please delete them:
/usr/share/pencil/chrome/icons/default/main-window.ico
/usr/share/pencil/chrome/icons/default/pencilMainWindow.ico
/usr/share/pencil/icons/default/main-window.ico
/usr/share/pencil/skin/classic/images/pencil.ico
/usr/share/pencil/skin/classic/pencil.ico

- what are those files for:
/usr/share/pencil/platform/WINNT
/usr/share/pencil/platform/WINNT/chrome.manifest
hint: you should review the list of included files in your rpm:
rpm -qlp pencil-2.0-2.fc19.noarch.rpm

- settings: path to external bitmap editor: is that correctable? currently, it points to /usr/local/bin/gimp-2.7 which is clearly wrong for several reasons.
Comment 14 Truong Anh Tuan 2012-09-28 22:33:32 EDT
(In reply to comment #13)

All issues have been addressed. Upstream developers have updated the sources and released as the new one 2.0.1.

The new .spec file: http://tuanta.fedorapeople.org/pencil/pencil.spec
The new .src file: http://tuanta.fedorapeople.org/pencil/pencil-2.0.1-1.fc17.src.rpm

Please review them for me. Thanks.

See some other comments below.

> [!]: MUST If (and only if) the source package includes the text of the
>      license(s) in its own file, then that file, containing the text of the
>      license(s) for the package is included in %doc.
> [!]: MUST License field in the package spec file matches the actual license.
>      Note: Checking patched sources after %prep for licenses. No licenses
>      found. Please check the source files for licenses manually.

This has been fixed.

> [!]: SHOULD Package has no %clean section with rm -rf %{buildroot} (or
>      $RPM_BUILD_ROOT)
>      Note: Clean is needed only if supporting EPEL5

Updated.

> [!]: MUST If (and only if) the source package includes the text of the
>      license(s) in its own file, then that file, containing the text of the
>      license(s) for the package is included in %doc.
> See: http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License_Text

Has been fixed. Keep only one license file (COPYING in root folder)

> Rpmlint
> -------
> Checking: pencil-2.0-2.fc19.src.rpm
>           pencil-2.0-2.fc19.noarch.rpm
> pencil.src: W: invalid-url Source0:
> http://evoluspencil.googlecode.com/files/pencil-2.0.tar.gz HTTP Error 404:
> Not Found

I think it's normal with source in Google code. You can try to download directly: http://evoluspencil.googlecode.com/files/pencil-2.0.1.tar.gz

> pencil.noarch: W: no-manual-page-for-binary pencil

There is no manual page in upstream source (it may be not necessary). Is it ok?

> Issues:
> 
> - please clarify with upstream, which license is is the one to use, ask
> upstream to delete the other
> - there are several files from windows included. please delete them:
> /usr/share/pencil/chrome/icons/default/main-window.ico
> /usr/share/pencil/chrome/icons/default/pencilMainWindow.ico
> /usr/share/pencil/icons/default/main-window.ico
> /usr/share/pencil/skin/classic/images/pencil.ico
> /usr/share/pencil/skin/classic/pencil.ico

Those files have been removed.

> - what are those files for:
> /usr/share/pencil/platform/WINNT
> /usr/share/pencil/platform/WINNT/chrome.manifest

Removed.

> - settings: path to external bitmap editor: is that correctable? currently,
> it points to /usr/local/bin/gimp-2.7 which is clearly wrong for several
> reasons.

Updated.
Comment 15 Matthias Runge 2012-10-01 07:53:21 EDT
Great!

Package is finally APPROVED
Comment 16 Truong Anh Tuan 2012-10-01 11:31:55 EDT
New Package SCM Request
=======================
Package Name: pencil
Short Description: A sketching and GUI prototyping tool
Owners: tuanta
Branches: f16 f17 f18 el6
InitialCC: mrunge
Comment 17 Gwyn Ciesla 2012-10-01 11:35:10 EDT
Git done (by process-git-requests).
Comment 18 Fedora Update System 2012-10-01 13:12:46 EDT
pencil-2.0.1-1.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/pencil-2.0.1-1.fc16
Comment 19 Fedora Update System 2012-10-01 13:16:23 EDT
pencil-2.0.1-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/pencil-2.0.1-1.fc18
Comment 20 Fedora Update System 2012-10-01 13:17:31 EDT
pencil-2.0.1-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/pencil-2.0.1-1.el6
Comment 21 Fedora Update System 2012-10-13 23:19:13 EDT
pencil-2.0.2-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/pencil-2.0.2-1.fc18
Comment 22 Fedora Update System 2012-10-13 23:20:15 EDT
pencil-2.0.2-1.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/pencil-2.0.2-1.fc17
Comment 23 Fedora Update System 2012-10-13 23:21:10 EDT
pencil-2.0.2-1.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/pencil-2.0.2-1.fc16
Comment 24 Fedora Update System 2012-10-13 23:22:11 EDT
pencil-2.0.2-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/pencil-2.0.2-1.el6

Note You need to log in before you can comment on or make changes to this bug.